import java.awt.Color;
import java.awt.Graphics;

public class Tree
{
    // Location of the tree base
    private double x;
    private double y;
    // Size of the tree
    private double size;
    // Orientation of the base
    private double orientation;
    
    
    public Tree(double x, double y, double size, double orientation)
    {
        this.x = x;
        this.y = y;
        this.size = size;
        this.orientation = orientation;
    }
    
    private static void drawLimb(Graphics g, double x, double y, double size, 
            double orientation, double brightness)
    {
        double newX = x + size * Math.cos(orientation);
        double newY = y + size * Math.sin(orientation);
        
        g.setColor(new Color(165, (int) brightness + 42, 42));
        
        g.drawLine((int) x , (int) y, (int) newX, (int) newY);
        if(size > 10)
        {
            double newBrightness = brightness + 30.0;
            if(newBrightness > 213.0)
                newBrightness = 213.0;
            
            // Recursive case
            drawLimb(g, newX, newY, size * .6, orientation - Math.PI/6, newBrightness);
            drawLimb(g, newX, newY, size * .6, orientation + Math.PI/8, newBrightness);
            
            newX = x + size * Math.cos(orientation) * 2.0 /3.0;
            newY = y + size * Math.sin(orientation) * 2.0 /3.0;
            drawLimb(g, newX, newY, size * .8, orientation + .5, newBrightness);
        }
        // ELSE: do nothing (base case)
    }


    protected void draw(Graphics g)
    {
        drawLimb(g, x, y, size, orientation, 0.0);
    }
}
